// #autoload
// #name = DioTR2HUD
// #version = 1.0
// #date = 10/1/2002 11:32AM
// #status = beta
// #author = Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://www.tribalpharmacy.com
// #description = Puts the "Hot Potato" time in a HUD for TR2. Invisible during CTF play.
// #category = DioScripts


if(!isobject(DioTRTimer)){
	new ScriptObject(DioTRTimer){
		class = DioTRTimer;
	};		
}

package DioTRTimer{
	
	function DioTRTimerGrab(){
		if(isEventPending(DioTRTimer.scheduleobj)) cancel(DioTRTimer.scheduleObj);
		DioTRTimer.scheduleobj = DioTRTimer.schedule(1000,update);
		DioTRTimer.timer = 17;
		DioTRTimerHUD.text.setvalue(DioTRTimer.timer);
		DioTRTimerHUD.text.setprofile("DioTRTGreen");
		DioTRTimerHUD.setvisible(true);
	}
	
	function DioTRTimeReset(){	
		if(isEventPending(DioTRTimer.scheduleobj)) cancel(DioTRTimerscheduleObj);
		DioTRTimerHUD.setvisible(false);
		DioTRTimer.timer = 0;
	}	
	
	function DioTRTimer::Update(%this){
		if(isEventPending(%this.scheduleobj)) cancel(%this.scheduleObj);
		%this.scheduleobj = %this.schedule(1000,update);
		%this.timer--;
		DioTRTimerHUD.text.setvalue(%this.timer);
		switch$(%this.timer){
			case "4": DioTRTimerHUD.text.setprofile("DioTRTRed");
			case "0": DioTRTimeReset();
		}
	}
	
	function DioTRTimer::Setup(%this){
		addMessageCallback('MsgTR2FlagTaken',DioTRTimerGrab);
		addMessageCallback('MsgTR2FlagDropped',DioTRTimeReset);
		addMessageCallback('MsgTR2ForcedRespawn',DioTRTimeReset);
		addMessageCallback('MsgTR2TeamScored',DioTRTimeReset);
		addMessageCallback('MsgClientJoinTeam',DioTRTimeReset);
		
		new GuiControlProfile ("DioTRTRed"){
			fontType = "Univers Bold";
			fontSize = 26;
			fontColor = "255 0 0";
			justify = "right";
		};
		new GuiControlProfile ("DioTRTGreen"){
			fontType = "Univers Bold";
			fontSize = 26;
			fontColor = "0 255 0";
			justify = "right";
		};				
	}
	
	function DioTRTimer::MakeHUD(%this){
		if(!isObject(DioTRTimerHUD)){			
			%x = getWord($pref::Video::resolution, 0)-190;
			%y = getWord(hudClusterBack.position, 1)+90;
			new ShellFieldCtrl(DioTRTimerHUD) {
				profile = "GuiChatBackProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = %x SPC %y;
				extent = "32 32";
				minExtent = "16 18";
				visible = "0";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};
			DioTRTimerHUD.text = new GuiTextCtrl() {
				profile = "DioTRTGreen";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "1 2";
				extent = "28 26";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			DioTRTimerHUD.add(DioTRTimerHUD.text);
			playgui.add(DioTRTimerHUD);
			if (isObject(HudMover)) hudmover::addhud(DioTRTimerHUD, "DioTR2Timer");
		}
	}
	
	function LoadingGui::onWake(%this){
		if (!DioTRTimer.Created){
			DioTRTimer.MakeHUD();
			DioTRTimer.Created = true;
		}
		parent::onWake(%this);
	}
	
};

activatePackage(DioTRTimer);

if($AutoloadExecuted)
	DioTRTimer.Setup();